
CoCoA-5 - Support #240

GUI compilation: GMP is not naturally thread-safe

27 Sep 2012 18:24 - Anna Maria Bigatti

Status: Closed Start date: 27 Sep 2012

Priority: Normal Due date:  

Assignee: John Abbott % Done: 100%

Category: GUI Estimated time: 3.33 hours

Target version: CoCoA-5.3.0 Spent time: 3.30 hours

Description

Difficult to notice, but it appears that the GUI (rarely) crashes (maybe!) for GMP not being thread-safe (the GUI runs in two threads)

One example making it crash is this

XX :=  ((10^131070-1984)/64)/((10^131232)/64);

 

[Right now I cannot find the exact fix by John (i.e. how to compile GMP with the "thread-safe" option)]

In conclusion, the GUI should be linked to a thread-safe gmp.

Design a way to automatically deal with this problem.

Related issues:

Related to CoCoA-5 - Support #1393: GUI with Qt5 Feedback 13 Jan 2020

History

#1 - 27 Sep 2012 18:26 - Anna Maria Bigatti

The first failing computation was (by L.Robbiano)

Use QQ[x];

F:=2*x*(1-x);

Pop:= Subst(F, x,  0.2);

For N:=2 To 20 Do

  Pop := Subst(F, x, Pop)

EndFor;

#2 - 27 Sep 2012 18:26 - Anna Maria Bigatti

- % Done changed from 0 to 10

#3 - 28 Sep 2012 12:49 - John Abbott

- Category set to GUI

- Status changed from New to In Progress

- Assignee set to John Abbott

- % Done changed from 10 to 50
I confirmed the problem using the GUI on my computer (Mac OS 10.5.8).

I reinstalled GMP (version 5.0.5), selecting a threadsafe build, and confirmed that the problem no longer exists.  The GMP configuration command I

used was:

./configure --enable-cxx --disable-alloca

The second option is the one which ensures that the build is threadsafe (but the GMP documentation says there will be a run-time speed penalty

).    

I am slightly puzzled because it seems to me that the GMP documentation suggests that the default setting for alloca would be threadsafe in any case

(perhaps Macs have a poor alloca function?)

#4 - 01 Oct 2012 11:38 - John Abbott

- Status changed from In Progress to Resolved

If Anna and Renzo confirm that my solution works for them too, I'll close this issue.

#5 - 01 Oct 2012 16:47 - Anna Maria Bigatti

it works for me!

#6 - 02 Apr 2014 17:33 - Anna Maria Bigatti

- Target version set to CoCoA-5.1.0 Easter14

#7 - 07 May 2014 13:43 - John Abbott

- Target version changed from CoCoA-5.1.0 Easter14 to CoCoA-5.1.1 Seoul14

#8 - 02 Sep 2014 11:27 - John Abbott

- Target version changed from CoCoA-5.1.1 Seoul14 to CoCoA-5.?.?

#9 - 02 Sep 2014 14:11 - John Abbott

JAA has confirmed (20140902) that the problem persists (with GMP 6.0.0 built without the --disable-alloca flag).

#10 - 28 Jan 2020 10:32 - John Abbott

- Related to Support #1393: GUI with Qt5 added

#11 - 17 Feb 2020 15:18 - John Abbott

- % Done changed from 50 to 60

This issue is very old.  GMP has surely changed over the last 5 years (but last update was about 2 years ago).

The old Qt interface does not work any more.

Should we just close this issue as "probably no longer relevant"?
#12 - 11 Mar 2020 21:34 - John Abbott

- Status changed from Resolved to Closed

- Target version changed from CoCoA-5.?.? to CoCoA-5.3.0

- % Done changed from 60 to 100

- Estimated time set to 3.33 h

No one seems to care about this issue; I'm pretty sure it has lost all relevance, so I'm closing it.
